wp = 0.2*pi; ws = 0.3*pi; tr_width = ws - wp; As = 50;
M = ceil((As-7.95)/(2.285*tr_width)+1)+1
n = [0:1:M-1]; beta = 0.1102*(As-8.7)
wc = (ws+wp)/2;  %frecuencia de corte ideal
hd = ideal_lp(wc,M); w_kai = (kaiser(M,beta))'; h = hd.* w_kai;
[db,mag,pha,grd,w] = freqz_m(h,[1]); delta_w = 2*pi/1000;
Rp = -(min(db(1:1:wp/delta_w+1)))  %Rizo en la banda pasante
As = -round(max(db(ws/delta_w+1:1:501)))  %Mnima atenuacin en la banda de rechazo
subplot(2,2,1); stem(n,hd); title('Respuesta al impulso ideal')
axis([0 M-1 -0.1 0.3]); ylabel('hd(n)')
subplot(2,2,2); stem(n,w_kai); title('Ventana de Kaiser')
axis([0 M-1 0 1.1]); ylabel('w(n)')
subplot(2,2,3); stem(n,h); title('Respuesta al impulso real')
axis([0 M-1 -0.1 0.3]); ylabel('h(n)')
subplot(2,2,4); plot(w/pi,db); title('Respuesta en frecuencia en dB'); grid
axis([0 1 -100 10]); ylabel('DBs')